#version 330 core
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec3 vertexNormal;
layout(location = 2) in vec3 vertexColor;
uniform mat4 MVP;

// Output data ; will be interpolated for each fragment.
out vec3 fragmentNormal;
out vec3 fragmentColor;
 
void main(){
 
    // Output position of the vertex, in clip space : MVP * position
    vec4 v = vec4(vertexPosition_modelspace,1); // Transform an homogeneous 4D vector, remember ?
    gl_Position = MVP * v;
	//gl_Position = v;

	// The color of each vertex will be interpolated
    // to produce the color of each fragment
    fragmentColor = vertexColor;

    fragmentNormal = vertexNormal;
}