#version 330 core

in vec3 fragmentNormal;
in vec3 fragmentPos;

out vec3 color;

uniform vec3 col;
uniform vec3 MVP_pos;
uniform vec3 lpoint;
uniform vec3 lpoint_col;
uniform float lpoint_amb;
uniform float lpoint_radius;
 
void main(){
	vec3 diff=lpoint-fragmentPos;
	float dist=length(diff)/lpoint_radius;
	diff=normalize(diff);
	vec3 normalnormal=normalize(fragmentNormal);
	float distatt=clamp(1-dist*dist,0,1);
	float distatt_refl=clamp(1-dist*dist/4,0,1);
	float diffuse=clamp(dot(normalnormal,diff*distatt),0,1);

	vec3 eye=normalize(MVP_pos-fragmentPos);
	vec3 reflected = reflect(-diff,normalnormal);
	float reflection = pow(clamp(dot( eye,reflected ),0,1),4)*0.33*distatt_refl;

	float val=lpoint_amb+diffuse*(1-lpoint_amb);
	color=col*val*lpoint_col+reflection;
}